﻿<?php

if ( ! isset( $content_width ) ) {

	$content_width = 474;

}



if ( version_compare( $GLOBALS['wp_version'], '3.6', '<' ) ) {

	require get_template_directory() . '/inc/back-compat.php';

}



if ( ! function_exists( 'twentyfourteen_setup' ) ) :

function twentyfourteen_setup() {



load_theme_textdomain( 'twentyfourteen', get_template_directory() . '/languages' );

add_editor_style( array( 'css/editor-style.css', twentyfourteen_font_url(), 'style.css' ) );

add_theme_support( 'automatic-feed-links' );

add_theme_support( 'post-thumbnails' );

set_post_thumbnail_size( 672, 372, true );

add_image_size( 'twentyfourteen-full-width', 1038, 576, true );



register_nav_menus( array(

		'primary'   => __( 'Top primary menu', 'twentyfourteen' ),

		'secondary' => __( 'Secondary menu in left sidebar', 'twentyfourteen' ),

	) );



	add_theme_support( 'html5', array(

		'search-form', 'comment-form', 'comment-list', 'gallery', 'caption'

	) );



	add_theme_support( 'post-formats', array(

		'aside', 'image', 'video', 'audio', 'quote', 'link', 'gallery',

	) );



	add_theme_support( 'custom-background', apply_filters( 'twentyfourteen_custom_background_args', array(

		'default-color' => 'f5f5f5',

	) ) );



	add_theme_support( 'featured-content', array(

		'featured_content_filter' => 'twentyfourteen_get_featured_posts',

		'max_posts' => 6,

	) );



	add_filter( 'use_default_gallery_style', '__return_false' );



	add_theme_support( 'customize-selective-refresh-widgets' );

}

endif;

add_action( 'after_setup_theme', 'twentyfourteen_setup' );



function twentyfourteen_content_width() {

	if ( is_attachment() && wp_attachment_is_image() ) {

		$GLOBALS['content_width'] = 810;

	}

}

add_action( 'template_redirect', 'twentyfourteen_content_width' );



function twentyfourteen_get_featured_posts() {



	return apply_filters( 'twentyfourteen_get_featured_posts', array() );

}



function twentyfourteen_has_featured_posts() {

	return ! is_paged() && (bool) twentyfourteen_get_featured_posts();

}



function twentyfourteen_widgets_init() {

	require get_template_directory() . '/inc/widgets.php';

	register_widget( 'Twenty_Fourteen_Ephemera_Widget' );



	register_sidebar( array(

'name'          => __( 'Primary Sidebar', 'twentyfourteen' ),

'id'            => 'sidebar-1',

'description'   => __( 'Main sidebar that appears on the left.', 'twentyfourteen' ),

'before_widget' => '<aside id="%1$s" class="widget %2$s">',

'after_widget'  => '</aside>',

'before_title'  => '<h1 class="widget-title">',

'after_title'   => '</h1>',

	) );

	register_sidebar( array(

'name'          => __( 'Content Sidebar', 'twentyfourteen' ),

'id'            => 'sidebar-2',

'description'   => __( 'Additional sidebar that appears on the right.', 'twentyfourteen' ),

'before_widget' => '<aside id="%1$s" class="widget %2$s">',

'after_widget'  => '</aside>',

'before_title'  => '<h1 class="widget-title">',

'after_title'   => '</h1>',

	) );

	register_sidebar( array(

'name'          => __( 'Footer Widget Area', 'twentyfourteen' ),

'id'            => 'sidebar-3',

'description'   => __( 'Appears in the footer section of the site.', 'twentyfourteen' ),

'before_widget' => '<aside id="%1$s" class="widget %2$s">',

'after_widget'  => '</aside>',

'before_title'  => '<h1 class="widget-title">',

'after_title'   => '</h1>',

	) );

}

add_action( 'widgets_init', 'twentyfourteen_widgets_init' );



function twentyfourteen_font_url() {

	$font_url = '';

	if ( 'off' !== _x( 'on', 'Lato font: on or off', 'twentyfourteen' ) ) {

$query_args = array(

'family' => urlencode( 'Lato:300,400,700,900,300italic,400italic,700italic' ),

'subset' => urlencode( 'latin,latin-ext' ),

);



	}

return $font_url;

}



function twentyfourteen_scripts() {

wp_enqueue_style( 'twentyfourteen-lato', twentyfourteen_font_url(), array(), null );

wp_enqueue_style( 'genericons', get_template_directory_uri() . '/style.css', array(), '4.5.14' );

wp_enqueue_style( 'twentyfourteen-style', get_stylesheet_uri() );

wp_enqueue_style( 'twentyfourteen-ie', get_template_directory_uri() . '/css/ie.css', array( 'twentyfourteen-style' ), '20131205' );

wp_style_add_data( 'twentyfourteen-ie', 'conditional', 'lt IE 9' );



if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {

wp_enqueue_script( 'comment-reply' );

	}



if ( is_singular() && wp_attachment_is_image() ) {

		wp_enqueue_script( 'twentyfourteen-keyboard-image-navigation', get_template_directory_uri() . '/js/keyboard-image-navigation.js', array( 'jquery' ), '20130402' );

	}

if ( is_active_sidebar( 'sidebar-3' ) ) {

		wp_enqueue_script( 'jquery-masonry' );

	}

if ( is_front_page() && 'slider' == get_theme_mod( 'featured_content_layout' ) ) {

	wp_enqueue_script( 'twentyfourteen-slider', get_template_directory_uri() . '/js/slider.js', array( 'jquery' ), '20131205', true );

	wp_localize_script( 'twentyfourteen-slider', 'featuredSliderDefaults', array(

	'prevText' => __( 'Previous', 'twentyfourteen' ),

	'nextText' => __( 'Next', 'twentyfourteen' )

		) );

	}

	wp_enqueue_script( 'twentyfourteen-script', get_template_directory_uri() . '/js/functions.js', array( 'jquery' ), '20150315', true );

}

add_action( 'wp_enqueue_scripts', 'twentyfourteen_scripts' );



function twentyfourteen_admin_fonts() {

	wp_enqueue_style( 'twentyfourteen-lato', twentyfourteen_font_url(), array(), null );

}

add_action( 'admin_print_scripts-appearance_page_custom-header', 'twentyfourteen_admin_fonts' );



if ( ! function_exists( 'twentyfourteen_the_attached_image' ) ) :



function twentyfourteen_the_attached_image() {

$post                = get_post();

$attachment_size     = apply_filters( 'twentyfourteen_attachment_size', array( 810, 810 ) );

$next_attachment_url = wp_get_attachment_url();



$attachment_ids = get_posts( array(

'post_parent'    => $post->post_parent,

'fields'         => 'ids',

'numberposts'    => -1,

'post_status'    => 'inherit',

'post_type'      => 'attachment',

'post_mime_type' => 'image',

'order'          => 'ASC',

'orderby'        => 'menu_order ID',

	) );





if ( count( $attachment_ids ) > 1 ) {

foreach ( $attachment_ids as $attachment_id ) {

if ( $attachment_id == $post->ID ) {

$next_id = current( $attachment_ids );

break;

}

}



		if ( $next_id ) {

			$next_attachment_url = get_attachment_link( $next_id );

		}



		else {

			$next_attachment_url = get_attachment_link( reset( $attachment_ids ) );

		}

	}



	printf( '<a href="%1$s" rel="attachment">%2$s</a>',

		esc_url( $next_attachment_url ),

		wp_get_attachment_image( $post->ID, $attachment_size )

	);

}

endif;



if ( ! function_exists( 'twentyfourteen_list_authors' ) ) :



function twentyfourteen_list_authors() {

$contributor_ids = get_users( array(

'fields'  => 'ID',

'orderby' => 'post_count',

'order'   => 'DESC',

'who'     => 'authors',

	) );



foreach ( $contributor_ids as $contributor_id ) :

$post_count = count_user_posts( $contributor_id );



if ( ! $post_count ) {

continue;

}

	?>



<div class="contributor">

<div class="contributor-info">

<div class="contributor-avatar"><?php echo get_avatar( $contributor_id, 132 ); ?></div>

<div class="contributor-summary">

<h2 class="contributor-name"><?php echo get_the_author_meta( 'display_name', $contributor_id ); ?></h2>

<p class="contributor-bio">

<?php echo get_the_author_meta( 'description', $contributor_id ); ?>

</p>

<a class="button contributor-posts-link" href="<?php echo esc_url( get_author_posts_url( $contributor_id ) ); ?>">

<?php printf( _n( '%d Article', '%d Articles', $post_count, 'twentyfourteen' ), $post_count ); ?>

</a>

</div><!-- .contributor-summary -->

</div><!-- .contributor-info -->

</div><!-- .contributor -->



<?php

endforeach;

}

endif;



function twentyfourteen_body_classes( $classes ) {

if ( is_multi_author() ) {

$classes[] = 'group-blog';
}



if ( get_header_image() ) {

$classes[] = 'header-image';

} elseif ( ! in_array( $GLOBALS['pagenow'], array( 'wp-activate.php', 'wp-signup.php' ) ) ) {

$classes[] = 'masthead-fixed';

}



if ( is_archive() || is_search() || is_home() ) {

$classes[] = 'list-view';

}



if ( ( ! is_active_sidebar( 'sidebar-2' ) )

|| is_page_template( 'page-templates/full-width.php' )

|| is_page_template( 'page-templates/contributors.php' )

|| is_attachment() ) {

$classes[] = 'full-width';

}



if ( is_active_sidebar( 'sidebar-3' ) ) {

$classes[] = 'footer-widgets';

}



if ( is_singular() && ! is_front_page() ) {

$classes[] = 'singular';

}



if ( is_front_page() && 'slider' == get_theme_mod( 'featured_content_layout' ) ) {

$classes[] = 'slider';

} elseif ( is_front_page() ) {

$classes[] = 'grid';

}



return $classes;

}

add_filter( 'body_class', 'twentyfourteen_body_classes' );



function twentyfourteen_post_classes( $classes ) {

if ( ! post_password_required() && ! is_attachment() && has_post_thumbnail() ) {

$classes[] = 'has-post-thumbnail';

}



return $classes;

}

add_filter( 'post_class', 'twentyfourteen_post_classes' );



function twentyfourteen_wp_title( $title, $sep ) {

global $paged, $page;

if ( is_feed() ) {

return $title;

}



$title .= get_bloginfo( 'name', 'display' );



$site_description = get_bloginfo( 'description', 'display' );

if ( $site_description && ( is_home() || is_front_page() ) ) {

$title = "$title $sep $site_description";

}



if ( ( $paged >= 2 || $page >= 2 ) && ! is_404() ) {

$title = "$title $sep " . sprintf( __( 'Page %s', 'twentyfourteen' ), max( $paged, $page ) );

}



return $title;

}

add_filter( 'wp_title', 'twentyfourteen_wp_title', 10, 2 );



require get_template_directory() . '/inc/custom-header.php';



require get_template_directory() . '/inc/template-tags.php';





require get_template_directory() . '/inc/customizer.php';



if ( ! class_exists( 'Featured_Content' ) && 'plugins.php' !== $GLOBALS['pagenow'] ) {

	require get_template_directory() . '/inc/featured-content.php';

}



/* 访问计数 */

function record_visitors()

{

if (is_singular())

{

global $post;

$post_ID = $post->ID;

if($post_ID)

{

$post_views = (int)get_post_meta($post_ID, 'views', true);

$post_views= $post_views+1;

if(!update_post_meta($post_ID, 'views', $post_views))

{

add_post_meta($post_ID, 'views', 1, true);

}

return $post_views;

}

}

}



function post_views()

{

global $post;

$post_ID = $post->ID;

$views = (int)get_post_meta($post_ID, 'views', true);

echo $views;

}



function post_views2()

{

$views = (int)get_post_meta(3, 'views1', true);

$views= $views+1;
if(!update_post_meta(3, 'views1', $views))

{

add_post_meta(3, 'views1', 1, true);

}

echo $views;

}

remove_action( 'wp_head', 'print_emoji_detection_script', 7 );
remove_action( 'wp_print_styles', 'print_emoji_styles' );

function refused_spam_comments( $comment_data )
{  $pattern = '/[一-龥]/u';  
if(!preg_match($pattern,$comment_data['comment_content']))
{  wp_die('评论必须含中文！');  }  
return( $comment_data );  }  
add_filter('preprocess_comment','refused_spam_comments');


