<!DOCTYPE html>



<html <?php language_attributes(); ?>>



<head>

	<meta charset="<?php bloginfo( 'charset' ); ?>">

	<meta name="viewport" content="width=device-width">

	<title><?php wp_title( '|', true, 'right' ); ?></title>

	<!--[if lt IE 9]>

	<script src="<?php echo get_template_directory_uri(); ?>/js/html5.js"></script>

	<![endif]-->

	<?php wp_head(); ?>

</head>



<body <?php body_class(); ?>>

<div id="page" class="hfeed site">

	<?php if ( get_header_image() ) : ?>

	<div id="site-header">

		<a href="<?php echo esc_url( home_url( '/' ) ); ?>" rel="home">

			<img src="<?php header_image(); ?>" width="<?php echo get_custom_header()->width; ?>" height="<?php echo get_custom_header()->height; ?>" alt="<?php echo esc_attr( get_bloginfo( 'name', 'display' ) ); ?>">

		</a>

	</div>

	<?php endif; ?>



	<header id="masthead" class="site-header" role="banner">

		<div class="header-main">

			<h1 class="site-title"><a href="<?php echo esc_url( home_url( '/' ) ); ?>" rel="home"><?php bloginfo( 'name' ); ?></a></h1>



			<div class="search-toggle">

				

			</div>



			<nav id="primary-navigation" class="site-navigation primary-navigation" role="navigation">

				<button class="menu-toggle"><?php _e( 'Primary Menu', 'twentyfourteen' ); ?></button>

				<a class="screen-reader-text skip-link" href="#content"><?php _e( 'Skip to content', 'twentyfourteen' ); ?></a>

				<?php wp_nav_menu( array( 'theme_location' => 'primary', 'menu_class' => 'nav-menu', 'menu_id' => 'primary-menu' ) ); ?>

			</nav>

		</div>



		<div id="search-container" class="search-box-wrapper hide">

			<div class="search-box">

				<?php get_search_form(); ?>

			</div>

		</div>

	</header><!-- #masthead -->



	<div id="main" class="site-main">

