<?php

class WP_Error {

public $errors = array();
public $error_data = array();
public function __construct( $code = '', $message = '', $data = '' ) {
if ( empty($code) )
return;

$this->errors[$code][] = $message;

if ( ! empty($data) )
$this->error_data[$code] = $data;
}
public function get_error_codes() {
if ( empty($this->errors) )
return array();

return array_keys($this->errors);
}

public function get_error_code() {
$codes = $this->get_error_codes();

if ( empty($codes) )
return '';

return $codes[0];
}

public function get_error_messages($code = '') {

if ( empty($code) ) {
$all_messages = array();
foreach ( (array) $this->errors as $code => $messages )
$all_messages = array_merge($all_messages, $messages);

return $all_messages;
}

if ( isset($this->errors[$code]) )
return $this->errors[$code];
else
return array();
}


public function get_error_message($code = '') {
if ( empty($code) )
$code = $this->get_error_code();
$messages = $this->get_error_messages($code);
if ( empty($messages) )
return '';
return $messages[0];
}

public function get_error_data($code = '') {
if ( empty($code) )
$code = $this->get_error_code();

if ( isset($this->error_data[$code]) )
return $this->error_data[$code];
}

public function add($code, $message, $data = '') {
$this->errors[$code][] = $message;
if ( ! empty($data) )
$this->error_data[$code] = $data;
}
public function add_data($data, $code = '') {
if ( empty($code) )
$code = $this->get_error_code();

$this->error_data[$code] = $data;
}

public function remove( $code ) {
unset( $this->errors[ $code ] );
unset( $this->error_data[ $code ] );
}
}

function is_wp_error( $thing ) {
return ( $thing instanceof WP_Error );
}
