<?php
 function wp_cache_add( $key, $data, $group = '', $expire = 0 ) { global $wp_object_cache; return $wp_object_cache->add( $key, $data, $group, (int) $expire ); } function wp_cache_close() { return true; } function wp_cache_decr( $key, $offset = 1, $group = '' ) { global $wp_object_cache; return $wp_object_cache->decr( $key, $offset, $group ); } function wp_cache_delete( $key, $group = '' ) { global $wp_object_cache; return $wp_object_cache->delete($key, $group); } function wp_cache_flush() { global $wp_object_cache; return $wp_object_cache->flush(); } function wp_cache_get( $key, $group = '', $force = false, &$found = null ) { global $wp_object_cache; return $wp_object_cache->get( $key, $group, $force, $found ); } function wp_cache_incr( $key, $offset = 1, $group = '' ) { global $wp_object_cache; return $wp_object_cache->incr( $key, $offset, $group ); } function wp_cache_init() { $GLOBALS['wp_object_cache'] = new WP_Object_Cache(); } function wp_cache_replace( $key, $data, $group = '', $expire = 0 ) { global $wp_object_cache; return $wp_object_cache->replace( $key, $data, $group, (int) $expire ); } function wp_cache_set( $key, $data, $group = '', $expire = 0 ) { global $wp_object_cache; return $wp_object_cache->set( $key, $data, $group, (int) $expire ); } function wp_cache_switch_to_blog( $blog_id ) { global $wp_object_cache; $wp_object_cache->switch_to_blog( $blog_id ); } function wp_cache_add_global_groups( $groups ) { global $wp_object_cache; $wp_object_cache->add_global_groups( $groups ); } function wp_cache_add_non_persistent_groups( $groups ) { } function wp_cache_reset() { _deprecated_function( __FUNCTION__, '3.5' ); global $wp_object_cache; $wp_object_cache->reset(); } class WP_Object_Cache { private $cache = array(); private $cache_hits = 0; public $cache_misses = 0; protected $global_groups = array(); private $blog_prefix; private $multisite; public function __get( $name ) { return $this->$name; } public function __set( $name, $value ) { return $this->$name = $value; } public function __isset( $name ) { return isset( $this->$name ); } public function __unset( $name ) { unset( $this->$name ); } public function add( $key, $data, $group = 'default', $expire = 0 ) { if ( wp_suspend_cache_addition() ) return false; if ( empty( $group ) ) $group = 'default'; $id = $key; if ( $this->multisite && ! isset( $this->global_groups[ $group ] ) ) $id = $this->blog_prefix . $key; if ( $this->_exists( $id, $group ) ) return false; return $this->set( $key, $data, $group, (int) $expire ); } public function add_global_groups( $groups ) { $groups = (array) $groups; $groups = array_fill_keys( $groups, true ); $this->global_groups = array_merge( $this->global_groups, $groups ); } public function decr( $key, $offset = 1, $group = 'default' ) { if ( empty( $group ) ) $group = 'default'; if ( $this->multisite && ! isset( $this->global_groups[ $group ] ) ) $key = $this->blog_prefix . $key; if ( ! $this->_exists( $key, $group ) ) return false; if ( ! is_numeric( $this->cache[ $group ][ $key ] ) ) $this->cache[ $group ][ $key ] = 0; $offset = (int) $offset; $this->cache[ $group ][ $key ] -= $offset; if ( $this->cache[ $group ][ $key ] < 0 ) $this->cache[ $group ][ $key ] = 0; return $this->cache[ $group ][ $key ]; } public function delete( $key, $group = 'default', $deprecated = false ) { if ( empty( $group ) ) $group = 'default'; if ( $this->multisite && ! isset( $this->global_groups[ $group ] ) ) $key = $this->blog_prefix . $key; if ( ! $this->_exists( $key, $group ) ) return false; unset( $this->cache[$group][$key] ); return true; } public function flush() { $this->cache = array(); return true; } public function get( $key, $group = 'default', $force = false, &$found = null ) { if ( empty( $group ) ) $group = 'default'; if ( $this->multisite && ! isset( $this->global_groups[ $group ] ) ) $key = $this->blog_prefix . $key; if ( $this->_exists( $key, $group ) ) { $found = true; $this->cache_hits += 1; if ( is_object($this->cache[$group][$key]) ) return clone $this->cache[$group][$key]; else return $this->cache[$group][$key]; } $found = false; $this->cache_misses += 1; return false; } public function incr( $key, $offset = 1, $group = 'default' ) { if ( empty( $group ) ) $group = 'default'; if ( $this->multisite && ! isset( $this->global_groups[ $group ] ) ) $key = $this->blog_prefix . $key; if ( ! $this->_exists( $key, $group ) ) return false; if ( ! is_numeric( $this->cache[ $group ][ $key ] ) ) $this->cache[ $group ][ $key ] = 0; $offset = (int) $offset; $this->cache[ $group ][ $key ] += $offset; if ( $this->cache[ $group ][ $key ] < 0 ) $this->cache[ $group ][ $key ] = 0; return $this->cache[ $group ][ $key ]; } public function replace( $key, $data, $group = 'default', $expire = 0 ) { if ( empty( $group ) ) $group = 'default'; $id = $key; if ( $this->multisite && ! isset( $this->global_groups[ $group ] ) ) $id = $this->blog_prefix . $key; if ( ! $this->_exists( $id, $group ) ) return false; return $this->set( $key, $data, $group, (int) $expire ); } public function reset() { _deprecated_function( __FUNCTION__, '3.5', 'switch_to_blog()' ); foreach ( array_keys( $this->cache ) as $group ) { if ( ! isset( $this->global_groups[ $group ] ) ) unset( $this->cache[ $group ] ); } } public function set( $key, $data, $group = 'default', $expire = 0 ) { if ( empty( $group ) ) $group = 'default'; if ( $this->multisite && ! isset( $this->global_groups[ $group ] ) ) $key = $this->blog_prefix . $key; if ( is_object( $data ) ) $data = clone $data; $this->cache[$group][$key] = $data; return true; } public function stats() { echo "<p>"; echo "<strong>Cache Hits:</strong> {$this->cache_hits}<br />"; echo "<strong>Cache Misses:</strong> {$this->cache_misses}<br />"; echo "</p>"; echo '<ul>'; foreach ($this->cache as $group => $cache) { echo "<li><strong>Group:</strong> $group - ( " . number_format( strlen( serialize( $cache ) ) / KB_IN_BYTES, 2 ) . 'k )</li>'; } echo '</ul>'; } public function switch_to_blog( $blog_id ) { $blog_id = (int) $blog_id; $this->blog_prefix = $this->multisite ? $blog_id . ':' : ''; } protected function _exists( $key, $group ) { return isset( $this->cache[ $group ] ) && ( isset( $this->cache[ $group ][ $key ] ) || array_key_exists( $key, $this->cache[ $group ] ) ); } public function __construct() { global $blog_id; $this->multisite = is_multisite(); $this->blog_prefix = $this->multisite ? $blog_id . ':' : ''; register_shutdown_function( array( $this, '__destruct' ) ); } public function __destruct() { return true; } }